# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
This contains the class for the IGE (In Game Editor)  

"""

from twisted.internet import defer

from mv3d.client.ui.Interfaces.IGE.client import IGEClientPlugin
from mv3d.util.classgen import ClassGenerator
from mv3d.util import math3d as VectorMath


uiloaded = 0

class addObject(IGEClientPlugin):
    """
    You need to add a docstring here ! 
    """
    def getName(self):
        """
        You need to add a docstring here ! 
        """
        return "Add Object"


    def GetSection(self):
        """
        You need to add a docstring here ! 
        """
        return "Object"


    def initialize(self, ui, ige, pi):
        """
        You need to add a docstring here ! 
        """
        self.ui = ui
        self.ige = ige
        self.plugin = pi


    def createButton(self, pos, sz, par):
        """
        You need to add a docstring here ! 
        """
        #print "Creating Add Butt"
        c = self.ui.createComponent("WindowsLook/SystemButton", 
            "Plugin_%s" % self.getName(), pos, sz, [0.01, 0.01], 
            [1.0, 1.0], "")
        self.ui.setButtonImages(c, "AddButtonN.png", "AddButtonH.png", "AddButtonA.png")
        par.addChildWindow(c)
        #print "Done"
        return c


    def start(self):
        """
        You need to add a docstring here ! 
        """
        d = self.plugin.callRemote("getAssetSelector")
        d.addCallback(self.GotAssetSelector)


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        pass


    def GotAssetSelector(self, a):
        """
        You need to add a docstring here ! 
        """
        self.asel = a
        d = self.asel.callRemote("GetUI")
        d.addCallback(self.GotAssetSelectUI)


    def GotAssetSelectUI(self, aui):
        """
        You need to add a docstring here ! 
        """
        d = aui.construct()
        if isinstance(d, defer.Deferred):
            d.addCallback(self.constructedAssetSelectorUI)
            return d
        return self.constructedAssetSelectorUI(d)


    def constructedAssetSelectorUI(self, aui):
        """
        You need to add a docstring here ! 
        """
        self.aui = aui
        aui.initialize(self.ui, self.asel)
        aui.SetAssetTypes([ClassGenerator(modulename = "mv3d.resource.asset", classname = "CodeAsset")])
        d = aui.start()
        d.addCallback(self.GotAsset)


    def GotAsset(self, asset):
        """
        You need to add a docstring here ! 
        """
        # now get the area and position....
        # for now, just take the area that we're in.
        if asset == 0:
            self.stop()
            return
        sc = self.ui.client.getInterface("Simulation Client")
        pc = sc.getItem(sc.pcid)
        d = self.plugin.callRemote("addObject", pc.areas.values()[0].getID(), 
            VectorMath.addVectors(pc.getPosition(), (0, 50, 50)), asset)
        d.addCallback(self.GotAsset_AddedObject)


    def GotAsset_AddedObject(self, r):
        """
        You need to add a docstring here ! 
        """
        # print r
        self.ige.SelectItem(r, 1)
        self.stop()


    def activated(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.start()
        except:
            import traceback
            traceback.print_exc()
