# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
"""


from twisted.internet import defer

from mv3d.client.ui.cegui import UserInterface


uiloaded = 0

class BasicProperties(UserInterface):
    """
    You need to add a docstring here ! 
    """
    def initialize(self, ui, i, ige):
        """
        You need to add a docstring here ! 
        """
        try:
            global uiloaded
            self.ui = ui
            self.interface = i
            self.ige = ige
            if not uiloaded:
                uiloaded = 1
                w = self.ui.createComponent("WindowsLook/FrameWindow", 
                    "BasicProperties", [0.25, 0.3], [0.5, 0.5], [0.01, 0.01], 
                    [1.0, 1.0], "Item Properties")
                iidl = ui.createComponent("WindowsLook/StaticText", 
                    "BasicProperties/IIDLText", [0.1, 0.1], [0.3, 0.1], [0.01, 0.01], [1.0, 1.0], 'ID:')
                iid = ui.createComponent("WindowsLook/StaticText", 
                    "BasicProperties/IIDText", [0.4, 0.1], [0.4, 0.1], [0.01, 0.01], [1.0, 1.0], '')
                nml = ui.createComponent("WindowsLook/StaticText", 
                    "BasicProperties/NMLText", [0.1, 0.2], [0.3, 0.1], [0.01, 0.01], [1.0, 1.0], 'Name:')
                nme = ui.createComponent("WindowsLook/Editbox", 
                    "BasicProperties/NMEEdit", [0.4, 0.2], [0.4, 0.1], [0.01, 0.01], [1.0, 1.0], '')
                cbtn = ui.createComponent("WindowsLook/Button", 
                    "BasicProperties/CButton", [0.4, 0.9], [0.2, 0.1], [0.01, 0.01], [1.0, 1.0], 'Cancel')
                abtn = ui.createComponent("WindowsLook/Button", 
                    "BasicProperties/AButton", [0.8, 0.9], [0.2, 0.1], [0.01, 0.01], [1.0, 1.0], 'Apply')
                okbtn = ui.createComponent("WindowsLook/Button", 
                    "BasicProperties/OKButton", [0.6, 0.9], [0.2, 0.1], [0.01, 0.01], [1.0, 1.0], 'Ok')
                w.addChildWindow(iidl)
                w.addChildWindow(iid)
                w.addChildWindow(nml)
                w.addChildWindow(nme)
                w.addChildWindow(cbtn)
                w.addChildWindow(abtn)
                w.addChildWindow(okbtn)
            self.window = self.ui.getComponent("BasicProperties")
        except:
            import traceback
            traceback.print_exc()


    def start(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.displayWindow(self.window)
        self.ccb = self.ui.requestUICallback("BasicProperties/CButton", "EventClicked", self, "Cancel")
        self.cncb = self.ui.requestUICallback("BasicProperties", "EventCloseClicked", self, "Cancel")
        self.acb = self.ui.requestUICallback("BasicProperties/AButton", "EventClicked", self, "Apply")
        self.ocb = self.ui.requestUICallback("BasicProperties/OKButton", "EventClicked", self, "Ok")
        d = self.interface.callRemote("GetInfo")
        d.addCallback(self.GotInfo)
        return d


    def GotInfo(self, inf):
        """
        You need to add a docstring here ! 
        """
        self.ui.getComponent("BasicProperties/IIDText").text = str(inf[0])
        self.ui.getComponent("BasicProperties/NMEEdit").text = inf[1]
        self.deferred = defer.Deferred()
        return self.deferred


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.hideWindow(self.window)
        self.ui.stopUICallback(self.ccb)
        self.ui.stopUICallback(self.cncb)
        self.ui.stopUICallback(self.acb)
        self.ui.stopUICallback(self.ocb)


    def Cancel(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.stop()
            self.deferred.callback(0)
        except:
            import traceback
            traceback.print_exc()


    def Apply(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            nm = self.ui.getComponent("BasicProperties/NMEEdit").text.c_str()
            self.interface.callRemote("setName", nm)
        except:
            import traceback
            traceback.print_exc()


    def Ok(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            nm = self.ui.getComponent("BasicProperties/NMEEdit").text.c_str()
            self.interface.callRemote("setName", nm)
            self.stop()
            self.deferred.callback(1)
        except:
            import traceback
            traceback.print_exc()
