# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
This contains the class for the IGE (In Game Editor)  
"""


from twisted.internet import defer

from mv3d.client.ui.Interfaces.IGE.client import IGEClientPlugin
from mv3d.client.ui.cegui import QuickQuestion

uiloaded = 0
class RemoveObject(IGEClientPlugin):
    """
    You need to add a docstring here ! 
    """
    def getName(self):
        """
        You need to add a docstring here ! 
        """
        return "Remove Object"


    def GetSection(self):
        """
        You need to add a docstring here ! 
        """
        return "Object"


    def initialize(self, ui, ige, pi):
        """
        You need to add a docstring here ! 
        """
        self.ui = ui
        self.ige = ige
        self.plugin = pi


    def createButton(self, pos, sz, par):
        """
        You need to add a docstring here ! 
        """
        # print "Creating remove butt"
        c = self.ui.createComponent("WindowsLook/SystemButton", 
            "Plugin_%s" % self.getName(), pos, sz, [0.01, 0.01], 
            [1.0, 1.0], "")
        self.ui.setButtonImages(c, "DelButtonN.png", "DelButtonH.png", "DelButtonA.png")
        par.addChildWindow(c)
        # print "Done"
        return c


    def start(self):
        """
        You need to add a docstring here ! 
        """
        d = QuickQuestion(self.ui, "Are you sure you want to\nremove the selection?", "Confirm Delete?")
        d.addCallback(self.UserReply)
        return d


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        pass


    def UserReply(self, d):
        """
        You need to add a docstring here ! 
        """
        self.stop()
        if d == 1:
            # user says ok!
            self.plugin.callRemote("RemoveItems", self.ige.GetSelection())
            # print "Removing!", self.ige.GetSelection()


    def activated(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.start()
        except:
            import traceback
            traceback.print_exc()
